'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require('react');
var _ = require('lodash');
var Field = require('lore-react-forms/Field');
var PayloadStates = require('lore-utils').PayloadStates;

var SelectField = function (_Field) {
  _inherits(SelectField, _Field);

  function SelectField() {
    _classCallCheck(this, SelectField);

    return _possibleConstructorReturn(this, (SelectField.__proto__ || Object.getPrototypeOf(SelectField)).apply(this, arguments));
  }

  _createClass(SelectField, [{
    key: 'onChange',
    value: function onChange(event, key, value) {
      this.onBlur();
      this.props.onChange(this.props.name, value);
      if (this.props.afterChange) {
        this.props.afterChange(this.props.onChange);
      }
    }
  }, {
    key: 'renderOption',
    value: function renderOption(option) {
      var text = option.text;
      var value = option.value;

      return React.createElement(
        'option',
        { key: value, value: value },
        text
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var name = this.props.name;
      var error = this.props.errors[name];
      var value = this.props.data[name];
      var touched = this.state.touched;

      var label = this.props.label;
      var options = this.props.options;
      var field = this.props.field;

      var displayError = touched && error;

      if (options.state === PayloadStates.FETCHING) {
        return React.createElement(
          'div',
          null,
          'Loading...'
        );
      }

      function mapDataToOptions(data) {
        return data.map(function (datum) {
          return {
            value: datum.id,
            text: datum.data[field]
          };
        });
      }

      var optionsData = mapDataToOptions(options.data);

      return React.createElement(
        'div',
        { className: "form-group" + (displayError ? " has-error" : "") },
        React.createElement(
          'label',
          null,
          label
        ),
        React.createElement(
          'select',
          { className: 'form-control' },
          [this.renderOption({ value: null, text: '' })].concat(optionsData.map(this.renderOption))
        ),
        displayError ? React.createElement(
          'span',
          { className: 'help-block' },
          error
        ) : null
      );
    }
  }]);

  return SelectField;
}(Field);

SelectField.propTypes = _.assign({}, Field.propTypes, {
  options: React.PropTypes.object.isRequired
});

SelectField.defaultProps = _.assign({}, Field.defaultProps, {
  options: {
    data: []
  }
});

module.exports = SelectField;